using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ValutaWindowsApplication
{
	/// <summary>
	/// Summary description for opretForm.
	/// </summary>
	public class VedligeholdForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox landBox;
		private System.Windows.Forms.TextBox isoBox;
		private System.Windows.Forms.TextBox KursBox;
		private System.Windows.Forms.TextBox logBox;
		private System.Windows.Forms.Button findButton;
		private System.Windows.Forms.Button retButton;

		private ValutaBeregner	beregner;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public VedligeholdForm(ValutaBeregner	beregner)
		{
			this.beregner = beregner;
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.landBox = new System.Windows.Forms.TextBox();
			this.isoBox = new System.Windows.Forms.TextBox();
			this.KursBox = new System.Windows.Forms.TextBox();
			this.logBox = new System.Windows.Forms.TextBox();
			this.findButton = new System.Windows.Forms.Button();
			this.retButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// landBox
			// 
			this.landBox.Location = new System.Drawing.Point(24, 24);
			this.landBox.Name = "landBox";
			this.landBox.TabIndex = 0;
			this.landBox.Text = "landBox";
			// 
			// isoBox
			// 
			this.isoBox.Location = new System.Drawing.Point(136, 24);
			this.isoBox.Name = "isoBox";
			this.isoBox.TabIndex = 1;
			this.isoBox.Text = "isoBox";
			// 
			// KursBox
			// 
			this.KursBox.Location = new System.Drawing.Point(248, 24);
			this.KursBox.Name = "KursBox";
			this.KursBox.TabIndex = 2;
			this.KursBox.Text = "KursBox";
			// 
			// logBox
			// 
			this.logBox.Location = new System.Drawing.Point(24, 104);
			this.logBox.Multiline = true;
			this.logBox.Name = "logBox";
			this.logBox.Size = new System.Drawing.Size(472, 136);
			this.logBox.TabIndex = 3;
			this.logBox.Text = "logBox";
			// 
			// findButton
			// 
			this.findButton.Location = new System.Drawing.Point(368, 24);
			this.findButton.Name = "findButton";
			this.findButton.TabIndex = 0;
			this.findButton.Text = "Find";
			this.findButton.Click += new System.EventHandler(this.findButton_Click);
			// 
			// retButton
			// 
			this.retButton.Location = new System.Drawing.Point(368, 48);
			this.retButton.Name = "retButton";
			this.retButton.TabIndex = 4;
			this.retButton.Text = "Ret";
			this.retButton.Click += new System.EventHandler(this.retButton_Click);
			// 
			// VedligeholdForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 266);
			this.Controls.Add(this.retButton);
			this.Controls.Add(this.findButton);
			this.Controls.Add(this.logBox);
			this.Controls.Add(this.KursBox);
			this.Controls.Add(this.isoBox);
			this.Controls.Add(this.landBox);
			this.Name = "VedligeholdForm";
			this.Text = "opretForm";
			this.ResumeLayout(false);

		}
		#endregion

		private void findButton_Click(object sender, System.EventArgs e)
		{
			string iso = this.isoBox.Text;
			string land = "";
			float kurs = 0;
			try
			{
				Valutakurs val = beregner[iso];
				land = val.Navn;
				kurs = val.Kurs;
				this.logBox.Text += "\r\nFundet kurs";
			}
			catch
			{
				this.logBox.Text += "\r\nFejl i iso:"+iso;
			}
			finally
			{
				this.landBox.Text = land;
				this.KursBox.Text = kurs.ToString();
			}
		}

		private void retButton_Click(object sender, System.EventArgs e)
		{
			string iso = this.isoBox.Text;
			float kurs = 0;
			try				// her laves hver "check" selvtndigt og yderste try
			{				// bruges til at checkke samlet - ved fejl "vidre kastes denne"
				try	
				{
					kurs = float.Parse(this.KursBox.Text.ToString());
				}
				catch(System.FormatException)
				{
					this.logBox.Text += "\r\nFejl kurs skal vre float:"+iso;
					throw;  // send execption videre for behandling
				}

				try
				{
					Valutakurs val = beregner[iso];
					this.landBox.Text = val.Navn;			// st land p skrm
					val.Kurs = kurs;
					this.logBox.Text += "\r\nKurs opdateret";
				}
				catch (FejlKursException)
				{
					this.logBox.Text += "\r\nFejl kurs ikke gyldig:"+iso;
					throw;  // send execption videre for behandling
				}
				catch (System.IndexOutOfRangeException)
				{
					this.logBox.Text += "\r\nFejl iso:"+iso+" findes ikke";
					throw;  // send execption videre for behandling
				}

			}
			catch		// her fanges vidresendte exception fra de enkelte kontroller
			{
				this.logBox.Text += "\r\nKurs er ikke opdateret:"+iso;
			}
		}
	}
}
